@echo off

rem ******************************************************************************
rem DELETE FILES FROM PREVIOUS BUILD
rem ******************************************************************************

if exist build.log del build.log
if exist error.log del error.log

rem ******************************************************************************
rem SET HMGPATH
rem -----------
rem
rem Using %~dp0 the HMGPATH is automatically set to current (hmg) folder making it
rem portable (zero config)
rem
rem ******************************************************************************

SET HMGPATH=%~dp0

rem ******************************************************************************
rem SET BINARIES PATHS
rem ******************************************************************************

SET PATH=%HMGPATH%\harbour\bin;%HMGPATH%\mingw\bin;%PATH%

rem *******************************************************************************


rem ******************************************************************************
rem COMPILE RESOURCES
rem ******************************************************************************

echo #define HMGRPATH %HmgPath%\RESOURCES > _hmg_resconfig.h
COPY /b %HMGPATH%\resources\hmg.rc+%~n1.rc+%HMGPATH%\resources\filler _temp.rc >NUL
windres -i _temp.rc -o _temp.o >windres.log 2>&1

rem *******************************************************************************


rem *******************************************************************************
rem SET PROJECT OUTPUT FILE NAME 
rem ----------------------------
rem
rem The first parameter sent to hbmk2 is -o%~n1.exe. I've added to it create the 
rem application with the project basename (<projectname.hbp> specified by the user.
rem
rem *******************************************************************************


rem *******************************************************************************
rem SET DEFAULT CONFIGURATION FILE
rem ------------------------------
rem
rem The second parameter sent to hbmk2 is the hmg.hbc script to set config required.
rem
rem *******************************************************************************


rem *******************************************************************************
rem RUN AFTER BUILD
rem ---------------
rem 
rem The third parameter sent to hbmk2 is -run (run after build).
rem
rem *******************************************************************************


rem ******************************************************************************
rem CALL HBMK2
rem ******************************************************************************

HBMK2 -o%~n1.exe %HMGPATH%\hmg.hbc -run %1 %2 %3 %4 %5 %6 %7 %8 >hbmk.log 2>&1

rem *******************************************************************************


rem ******************************************************************************
rem CREATE LOGS
rem ******************************************************************************

if errorlevel 1 if exist windres.log copy /a windres.log+hbmk.log error.log >nul
if errorlevel 1 if not exist windres.log copy /a hbmk.log error.log >nul

if errorlevel 0 if exist windres.log copy /a windres.log+hbmk.log build.log >nul
if errorlevel 0 if not exist windres.log copy /a hbmk.log build.log >nul

rem ******************************************************************************
rem CLEANUP
rem ******************************************************************************

if exist windres.log del windres.log
if exist hbmk.log del hbmk.log
if exist _hmg_resconfig.h del _hmg_resconfig.h
if exist _temp.rc del _temp.rc
if exist _temp.o  del _temp.o

rem ******************************************************************************
rem SHOW LOG
rem ******************************************************************************

if exist error.log type error.log
if exist build.log type build.log
